package GUI;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.List;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;

import GUI.MatrixWindow.TableListener;
import MainPackage.Job;
import MainPackage.Project;
import Tropical.Mathematics.Matrix;

public class ConstraintsAddWindow extends JFrame {
	Matrix b;
	final JTable tab;

	public ConstraintsAddWindow(final Project p, final MainWindow mw,
			List<Matrix> list) {
		super("Make Constraints");
		b = list.get(3);
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		int n = b.getRowSize();
		tab = new JTable(2, n + 1);
		DefaultTableModel dtm = new DefaultTableModel() {
			public boolean isCellEditable(int row, int column) {
				if (row == 0 || column == 0) {
					return false;
				} else {
					return true;
				}
			}
		};
		dtm.setRowCount(n + 1);
		dtm.setColumnCount(2);
		dtm.addTableModelListener(new TableListener());
		tab.setModel(dtm);
		fillTable(b, p);

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				mw.collectInfoMatrixCosntraints();
			}
		});
		JPanel jp = new JPanel();
		BoxLayout bl = new BoxLayout(jp, BoxLayout.Y_AXIS);
		jp.setLayout(bl);
		jp.add(Box.createVerticalGlue());
		JLabel lab = new JLabel("  : ");
		lab.setAlignmentX(lab.CENTER_ALIGNMENT);
		lab.setAlignmentY(lab.TOP_ALIGNMENT);
		jp.add(lab);
		jp.add(tab);
		getContentPane().add(jp);
		pack();

		setSize(300, 200);
		setVisible(true);
	}

	public void fillTable(Matrix m, Project p) {
		int n = m.getRowSize();

		Object[] jobsname = new Object[n];
		int k = 0;
		for (Job j : p.getAllJobs())
			jobsname[k++] = j.getName();
		for (int i = 0; i < n + 1; i++) {
			for (int j = 0; j < m.getColumnSize() + 1; j++) {
				if ((i == 0 && j == 0)) {
					tab.getModel().setValueAt("Jobs", i, j);
					continue;
				}
				if ((i == 0 && j == 1)) {
					tab.getModel().setValueAt("Constraints", i, j);
					continue;
				}
				if (j == 0) {
					tab.getModel().setValueAt(jobsname[i + j - 1], i, j);
				} else {
					tab.getModel().setValueAt(m.getValueAt(i - 1, j - 1), i, j);
				}
			}
		}

	}

	class TableListener implements TableModelListener {

		@Override
		public void tableChanged(TableModelEvent e) {

			// System.out.println(e.getSource());
			int y = e.getLastRow();
			int x = e.getColumn();

			System.out.print(e.getColumn() + " ");
			System.out.println(e.getLastRow());
			if (x == 0 || y == 0) {
				return;
			}
			double value = 0;
			int rowcount = tab.getRowCount() - 1;
			if (!(tab.getModel().getValueAt(y, x) instanceof Double)) {

				String s = (String) tab.getModel().getValueAt(y, x);
				if (s == "-Infinity") {
					value = Double.NEGATIVE_INFINITY;
				} else {
					try {
						value = Double.valueOf(s);
					} catch (NumberFormatException ex) {
						JOptionPane.showMessageDialog(new JFrame(),
								"Incorrect input!!", "Dialog",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
				}
				ConstraintsAddWindow.this.b.setValueAt(value, y - 1, x - 1);
			}
		}
	}

	public Matrix collectInfo() {
		// TODO Auto-generated method stub
		return b;
	}
}
