package GUI;

import java.awt.*;
import java.awt.color.CMMException;
import java.awt.event.*;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.swing.*;

import MainPackage.*;

public class JobAddWindow extends JFrame {
	Project thisproj;
	LinkedList<Job> jobslist;
	LinkedList<Resource> resourcelist;

	public JobAddWindow(MainWindow mw) {
		super("Add new job");
		thisproj = MainClass.getInstance();
		final JFrame jf = this;
		setSize(400, 400);
		setResizable(true);
		// setMaximumSize(new Dimension(500, 400));
		setMinimumSize(new Dimension(400, 300));
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		final JLabel jobname = new JLabel("Enter the job's title:");
		String jlength = "Enter job's length";
		switch (mw.PRECIZE_OF_MATRIX) {
		case "sec":
			jlength += " (in sec):";
			break;
		case "min":
			jlength += " (in min):";
			break;
		case "Hour":
			jlength += " (in hours):";
			break;
		case "Day":
			jlength += " (in days):";
			break;
		}

		final JLabel joblength = new JLabel(jlength);
		JLabel selectprev = new JLabel("Select previous job:"), selectnext = new JLabel(
				"Select next job:"), reslabel = new JLabel("Select resource:"), starttimelab = new JLabel(
				"Select early start time:"), stoptimelab = new JLabel(
				"Select late stop time:");
		final JComboBox jcbprevjob; // soon i'll insert here jobs
		final JComboBox jcbnextjob; // soon i'll insert here jobs
		final JSpinner jsp;
		jobslist = thisproj.getAllJobs();
		resourcelist = thisproj.getAllResources();
		if (!thisproj.getAllJobs().isEmpty()) {
			Object[] jobsarray = jobslist.toArray();
			DefaultComboBoxModel dcmbprev = new DefaultComboBoxModel(jobsarray), dcmbnext = new DefaultComboBoxModel(
					jobsarray);
			dcmbprev.addElement(null);
			dcmbnext.addElement(null);
			jcbprevjob = new JComboBox(dcmbprev);
			jcbnextjob = new JComboBox(dcmbnext);
		} else {
			jcbprevjob = new JComboBox();
			jcbnextjob = new JComboBox();
		}
		final JComboBox jcbresources;// soon i'll insert here
		// resources
		if (!resourcelist.isEmpty()) {
			Object[] jobsarray = resourcelist.toArray();
			DefaultComboBoxModel dcmbres = new DefaultComboBoxModel(jobsarray);
			dcmbres.addElement(null);
			jcbresources = new JComboBox(dcmbres);
		} else {
			jcbresources = new JComboBox();

		}

		final JTextField jtf = new JTextField("Job#" + jobslist.size());
		Calendar cal = Calendar.getInstance();
		Date now = cal.getTime();
		cal.add(Calendar.YEAR, -50);
		Date startDate = cal.getTime();
		cal.add(Calendar.YEAR, 100);
		Date endDate = cal.getTime();
		SpinnerModel modelart = new SpinnerDateModel(now, startDate, endDate,
				Calendar.YEAR);
		SpinnerModel modelop = new SpinnerDateModel(now, startDate, endDate,
				Calendar.YEAR);
		jsp = new JSpinner(new SpinnerNumberModel(0, 0, Integer.MAX_VALUE, 1));
		final JSpinner spinnerstop = new JSpinner(modelop);
		final JSpinner spinnerstart = new JSpinner(modelart);

		JPanel choisepan = new JPanel();
		BoxLayout bl = new BoxLayout(choisepan, BoxLayout.Y_AXIS);
		choisepan.setLayout(bl);
		choisepan.add(jobname);
		choisepan.add(jtf);
		choisepan.add(selectprev);
		choisepan.add(jcbprevjob);
		choisepan.add(selectnext);
		choisepan.add(jcbnextjob);
		choisepan.add(reslabel);
		choisepan.add(jcbresources);

		choisepan.add(starttimelab);
		choisepan.add(spinnerstart);
		choisepan.add(stoptimelab);
		choisepan.add(spinnerstop);
		choisepan.add(joblength);
		choisepan.add(jsp);
		JButton butOk = new JButton("Add");
		butOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yy HH:mm");
				Date dsta = (Date) spinnerstart.getValue(), dsto = (Date) spinnerstop
						.getValue();
				long length = Long.valueOf((String.valueOf(jsp.getValue())));
				if (!jobslist.isEmpty()) {
					Job prevjob = (Job) jcbprevjob.getSelectedItem(), nextjob = (Job) jcbnextjob
							.getSelectedItem();
					if (prevjob == nextjob && nextjob != null) {
						JOptionPane.showMessageDialog(new JFrame(),
								"Can't make loop of previous and next job",
								"Dialog", JOptionPane.ERROR_MESSAGE);
						return;
					}
					//    
					// if (prevjob.getStopTime() != null
					// && prevjob.getStopTime().after(dsta)) {
					// JOptionPane.showMessageDialog(new JFrame(),
					// "Can't start before previous work isn't done!",
					// "Dialog", JOptionPane.ERROR_MESSAGE);
					// return;
					// }
					// if (nextjob.getStartTime() != null
					// && nextjob.getStartTime().after(dsto)) {
					// JOptionPane.showMessageDialog(new JFrame(),
					// "Can't stop after next work starts!",
					// "Dialog", JOptionPane.ERROR_MESSAGE);
					// return;
					// }
					if (dsta.after(dsto) || !dsta.before(dsto)) {
						JOptionPane.showMessageDialog(new JFrame(),
								"Starttime can't be after stoptime!", "Dialog",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					long duration = dsta.getTime();
					duration += length * 24 * 60 * 60 * 1000;
					Date dares = new Date(duration);
					if (dares.after(dsto)) {
						JOptionPane.showMessageDialog(new JFrame(),
								"Total length time can't be so long!",
								"Dialog", JOptionPane.ERROR_MESSAGE);
						return;
					}
					if (resourcelist.isEmpty()) {
						thisproj.addJob(new Job(jtf.getText(), dsta, dsto,
								prevjob, nextjob, length));
					} else {
						Resource res = (Resource) jcbresources
								.getSelectedItem();
						thisproj.addJob(new Job(jtf.getText(), dsta, dsto,
								prevjob, nextjob, res, length));
					}

				} else {
					thisproj.addJob(new Job(jtf.getText(), dsta, dsto, length));
				}
				jf.dispose();
			}
		});
		JButton butCan = new JButton("Cancel");
		butCan.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				jf.dispose();

			}
		});
		getContentPane().add(choisepan, "North");
		JPanel butpan = new JPanel();
		bl = new BoxLayout(butpan, BoxLayout.X_AXIS);
		butpan.setLayout(bl);
		butpan.add(butOk, "South");
		butpan.add(Box.createHorizontalStrut(10));
		butpan.add(butCan, "South");
		butpan.add(Box.createHorizontalStrut(10));
		getContentPane().add(butpan, "East");
		setVisible(true);
	}
}
