package GUI;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.swing.*;

import MainPackage.*;

public class JobEditWindow extends JFrame {
	Project thisproj;
	LinkedList<Job> jobslist;
	LinkedList<Resource> resourcelist;

	public JobEditWindow(final MainWindow mw, final Job j) {
		super("Edit job");
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		thisproj = MainClass.getInstance();
		jobslist = new LinkedList<Job>(thisproj.getAllJobs());
		jobslist.remove(j);
		resourcelist = thisproj.getAllResources();
		final JLabel joblength = new JLabel("Job's length (in days):");
		final JLabel jobname = new JLabel("Job's title:");
		JLabel selectprev = new JLabel("Previous job:");
		JLabel selectnext = new JLabel("Next job:");
		JLabel reslabel = new JLabel("Resource:");
		JLabel starttimelab = new JLabel("Early start time:");
		JLabel stoptimelab = new JLabel("Late Stop time:");
		final JList<Job> jlistbprev, jlistbnext;
		// final JComboBox jcbprevjob; //
		// final JComboBox jcbnextjob; //
		Object[] ojobsarray = jobslist.toArray();
		Job[] jobsarray = new Job[ojobsarray.length];
		for (int i = 0; i < ojobsarray.length; i++) {
			jobsarray[i] = (Job) ojobsarray[i];
		}
		if (!thisproj.getAllJobs().isEmpty()) {

			jlistbnext = new JList<Job>(jobsarray);
			jlistbprev = new JList<Job>(jobsarray);
			LinkedList<Integer> selind = new LinkedList<Integer>();// selected
			for (Job prevj : j.getPreviousJob()) // indices
			{
				selind.add(jobslist.indexOf(prevj));
			}
			int[] sel = new int[selind.size()];
			for (int i = 0; i < selind.size(); i++) {
				sel[i] = selind.get(i);
			}
			jlistbprev.setSelectedIndices(sel);
			selind.clear();
			for (Job nextj : j.getNextJob()) // indices
			{
				selind.add(jobslist.indexOf(nextj));
			}
			sel = new int[selind.size()];
			for (int i = 0; i < selind.size(); i++) {
				sel[i] = selind.get(i);
			}
			jlistbnext.setSelectedIndices(sel);
		} else {
			jlistbnext = new JList<Job>(jobsarray);
			jlistbprev = new JList<Job>(jobsarray);
		}
		final JComboBox jcbresources;// soon i'll insert here
		// resources
		if (!resourcelist.isEmpty()) {
			DefaultComboBoxModel dcmbres = new DefaultComboBoxModel(jobsarray);
			dcmbres.addElement(null);
			dcmbres.setSelectedItem(j.getResource());
			jcbresources = new JComboBox(dcmbres);
		} else {
			jcbresources = new JComboBox();
		}
		final JTextField jtf = new JTextField(j.getName());

		Calendar cal = Calendar.getInstance();
		cal.add(Calendar.YEAR, -50);
		Date startDate = cal.getTime();
		cal.add(Calendar.YEAR, 100);
		Date endDate = cal.getTime();
		SpinnerModel modelart = new SpinnerDateModel(j.getStartTime(),
				startDate, endDate, Calendar.YEAR);
		SpinnerModel modelop = new SpinnerDateModel(j.getStopTime(), startDate,
				endDate, Calendar.YEAR);

		final JSpinner spinnerstop = new JSpinner(modelop);
		final JSpinner spinnerstart = new JSpinner(modelart);
		final JSpinner jsp = new JSpinner(new SpinnerNumberModel(j.getLength(),
				0, Integer.MAX_VALUE, 1));

		final JFrame jf = this;
		JPanel choisepan = new JPanel();
		BoxLayout bl = new BoxLayout(choisepan, BoxLayout.Y_AXIS);
		choisepan.setLayout(bl);
		choisepan.add(jobname);
		choisepan.add(jtf);
		JPanel hor = new JPanel(new GridLayout(2, 2, 5, 0));

		hor.add(selectprev);
		hor.add(selectnext);
		hor.add(jlistbprev);
		hor.add(jlistbnext);
		choisepan.add(hor);
		choisepan.add(reslabel);
		choisepan.add(jcbresources);

		choisepan.add(starttimelab);
		choisepan.add(spinnerstart);
		choisepan.add(stoptimelab);
		choisepan.add(spinnerstop);
		choisepan.add(joblength);
		choisepan.add(jsp);
		setMinimumSize(new Dimension(400, 400));
		pack();
		JButton butOk = new JButton("Save");
		butOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				SimpleDateFormat sdf = new SimpleDateFormat("dd-MM-yy HH:mm");
				String s = String.valueOf(jsp.getValue());
				Double d = Double.valueOf(s);
				long length = d.longValue();
				Date dsta = (Date) spinnerstart.getValue(), dsto = (Date) spinnerstop
						.getValue();
				List<Job> prevjob = jlistbprev.getSelectedValuesList(), nextjob = jlistbnext
						.getSelectedValuesList();

				for (Job pj : prevjob) {
					for (Job nj : nextjob) {
						if (pj == nj && nj != null) {
							JOptionPane.showMessageDialog(new JFrame(),
									"Can't make loop of previous and next job",
									"Dialog", JOptionPane.ERROR_MESSAGE);
							return;
						}
					}
				}
				if (dsta.after(dsto) || !dsta.before(dsto)) {
					JOptionPane.showMessageDialog(new JFrame(),
							"Starttime can't be after stoptime!", "Dialog",
							JOptionPane.ERROR_MESSAGE);
					return;
				}
				long duration = dsta.getTime();
				duration += length * 24 * 60 * 60 * 1000;
				Date dares = new Date(duration);
				if (dares.after(dsto)) {
					JOptionPane.showMessageDialog(new JFrame(),
							"Total length time can't be so long!", "Dialog",
							JOptionPane.ERROR_MESSAGE);
					return;
				}

				if (j.getName() != jtf.getText())
					j.setName(jtf.getText());

				if (prevjob != j.getPreviousJob()) {
					j.removePreviousJob();
					for (Job jj : prevjob)
						j.setPreviousJob(jj);
				}
				if (nextjob != j.getNextJob()) {
					j.removeNextJob();
					for (Job jj : nextjob)
						j.setNextJob(jj);
				}
				if (length != j.getLength()) {
					j.setLength(length);
				}
				Resource res = (Resource) jcbresources.getSelectedItem();

				if (res != j.getResource())
					if (res == null)
						thisproj.removeResourceFromJob(j);
					else
						j.setResource(res);

				if (dsta.after(j.getStartTime())
						|| dsta.before(j.getStartTime()))
					j.setStartTime(dsta);

				if (dsto.after(j.getStopTime()) || dsto.before(j.getStopTime()))
					j.setStopTime(dsto);
				thisproj.valueChanged();
				jf.dispose();
			}
		});
		JButton butCan = new JButton("Cancel");
		butCan.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				jf.dispose();

			}
		});
		getContentPane().add(choisepan, "North");
		JPanel butpan = new JPanel();
		bl = new BoxLayout(butpan, BoxLayout.X_AXIS);
		butpan.setLayout(bl);
		butpan.add(butOk, "South");
		butpan.add(Box.createHorizontalStrut(10));
		butpan.add(butCan, "South");
		butpan.add(Box.createHorizontalStrut(10));
		getContentPane().add(butpan, "East");
		setVisible(true);
	}
}
