package GUI;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import com.mxgraph.model.mxCell;
import com.mxgraph.layout.*;
import com.mxgraph.swing.*;
import com.mxgraph.util.mxConstants;
import com.mxgraph.view.mxGraph;
import com.mxgraph.view.mxStylesheet;

/*import org.jfree.chart.ChartFactory;
 import org.jfree.chart.ChartPanel;
 import org.jfree.chart.JFreeChart;
 import org.jfree.data.category.IntervalCategoryDataset;
 import org.jfree.data.gantt.Task;
 import org.jfree.data.gantt.TaskSeries;
 import org.jfree.data.gantt.TaskSeriesCollection;
 import org.jfree.data.time.SimpleTimePeriod;
 import org.jfree.ui.ApplicationFrame;
 */
import org.swiftgantt.GanttChart;
import org.swiftgantt.common.Time;
import org.swiftgantt.event.SelectionChangeEvent;
import org.swiftgantt.event.SelectionChangeListener;
import org.swiftgantt.model.GanttModel;
import org.swiftgantt.model.Task;
import org.swiftgantt.ui.TimeUnit;

import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.*;

import java.util.List;

import Tropical.Mathematics.*;
import Tropical.ProjectScheduling.Scheduling;
import MainPackage.*;

public class MainWindow extends JFrame {
	/*
	 * IntervalCategoryDataset dataset; JFreeChart jfch; ChartPanel chp;
	 */

	/**
	 * 
	 */
	Matrix A, C, B, bConst;
	private static final long serialVersionUID = 1L;
	// GanttModel project;
	JScrollPane scroll;
	JPanel timeViewPanel;
	static String PRECIZE = "Hour";
	static String PRECIZE_OF_MATRIX = "Day";
	// ///////////////////////////////
	// menu strip
	final JMenuBar jmb;
	MainWindow mw = null;
	MatrixWindow mm = null;
	ConstraintsAddWindow cmm = null;
	Project thisproj = MainClass.getInstance();
	Map<Job, Resource> guijob = new HashMap<Job, Resource>();
	Map<Resource, Job> guiresTable = new HashMap<Resource, Job>();
	transient LinkedList<Object> verties = new LinkedList<Object>();

	transient mxGraph mGraph = new mxGraph() {
		@Override
		public String getToolTipForCell(Object cell) {
			if (cell instanceof mxCell) {
				mxCell c = (mxCell) cell;
				Object uo = c.getValue();
				if (uo instanceof Job) {
					Job userObject = (Job) uo;
					return userObject.getFullInfo();
				} else {
					return super.getToolTipForCell(cell);
				}
			}
			return super.getToolTipForCell(cell);
		};
	};
	transient mxGraphComponent mxGpraphComp = new mxGraphComponent(mGraph);

	// //////////////////////////////////////
	// /graph

	public void clearAll() {
		guijob.clear();
		nn.clear();
		guires.clear();
		guiresTable.clear();
		verties.clear();

	}

	// /////////////////////////////////////
	// /table
	JTable jtable;
	DefaultTableModel defTalbe = new DefaultTableModel() {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		@Override
		public boolean isCellEditable(int row, int column) {
			// all cells false
			return false;
		}
	};
	// /////////////////////////////////
	// tree
	JTree projecttree;
	DefaultMutableTreeNode root = new DefaultMutableTreeNode(thisproj);
	DefaultTreeModel dtm = new DefaultTreeModel(root, true);

	void reDrawTable(JTable t, DefaultTableModel dt, Project pr) {
		int res = 1;

		LinkedList<Resource> resources = pr.getAllResources();
		t.getColumnModel().getColumn(0).setMaxWidth(50);
		dt.getDataVector().removeAllElements();
		dt.fireTableDataChanged();
		if (!resources.isEmpty()) {
			for (Resource r : resources) {
				// if (!guiresTable.containsKey(r)) {
				guiresTable.put(r, null);
				int jobs = 1;
				dt.addRow(new Object[] { String.valueOf(res++), r });

				if (!r.getJobs().isEmpty()) {
					LinkedList<Job> jbs = r.getJobs();
					for (Job j : jbs) {
						// if (!guiresTable.containsValue(j)) {
						guiresTable.put(r, j);
						dt.addRow(new Object[] {
								String.valueOf(res - 1) + "."
										+ String.valueOf(jobs++), j,
								j.getStartTime().toString(),
								j.getStopTime().toString() });
						// }
						// }
					}
				}
			}
		}
	}

	void reDrawGraph(mxGraph gr, Project pr) {
		// get graph stylesheet
		mxStylesheet stylesheet = gr.getStylesheet();

		// define image style name
		String myStyleName = "myImageStyle";
		Hashtable<String, Object> style = new Hashtable<String, Object>();
		style.put(mxConstants.STYLE_SHAPE, mxConstants.SHAPE_IMAGE);
		style.put(mxConstants.STYLE_IMAGE, "/src/IMG/task.jpg");
		style.put(mxConstants.STYLE_VERTICAL_LABEL_POSITION,
				mxConstants.ALIGN_BOTTOM);
		stylesheet.putCellStyle(myStyleName, style);

		LinkedList<Job> jobs = pr.getAllJobs();
		LinkedList<Object> edges = new LinkedList<Object>();
		LinkedList<Resource> resources = pr.getAllResources();
		Object par = gr.getDefaultParent();
		gr.getModel().beginUpdate();
		// for (Object v : verties) {
		// gr.getModel().remove(v);
		// }
		gr.removeCells(gr.getChildCells(gr.getDefaultParent(), true, true));
		gr.removeCellsFromParent();
		// gr.remove();
		try {

			for (Job jb : jobs) {
				boolean hasthis = false;
				for (Object v : verties) {
					Job j = (Job) ((mxCell) v).getValue();
					if (j.hashCode() == jb.hashCode()) {
						hasthis = true;
					}
				}
				if (hasthis) {
					continue;
				}
				verties.add(gr.insertVertex(par, null, jb, 20, 20, 60, 40,
						"shape=image;image=/src/IMG/task.jpg"));
			}

			for (int i = 0; i < jobs.size(); i++) {
				for (int j = 0; j < jobs.size(); j++) {
					for (Job jn : jobs.get(i).getNextJob()) {
						if (jn == jobs.get(j)) {
							edges.add(gr.insertEdge(par, null, "",
									verties.get(i), verties.get(j)));
						}
					}
					// if (jobs.get(i).getPreviousJob() == jobs.get(j)
					// // || jobs.get(i).getPreviousJob() == jobs.get(j)) {
					// ) {
					// edges.add(gr.insertEdge(par, null, "", verties.get(j),
					// verties.get(i)));
					// }
					// if (jobs.get(i).getNextJob() == jobs.get(j)
					// // || jobs.get(i).getPreviousJob() == jobs.get(j)) {
					// ) {
					// edges.add(gr.insertEdge(par, null, "", verties.get(i),
					// verties.get(j)));
					// }
				}
			}
		} finally {
			gr.getModel().endUpdate();
		}
		mxCompactTreeLayout mxTreel = new mxCompactTreeLayout(mGraph);
		mxTreel.setEdgeRouting(true);
		mxTreel.setHorizontal(false);
		mxTreel.setNodeDistance(80);
		if (!verties.isEmpty())
			mxTreel.setVertexLocation(verties.get(0), 300, 50);

		mxTreel.execute(mGraph.getDefaultParent());
		// mxFastOrganicLayout layout = new mxFastOrganicLayout(mGraph);
		// layout.setMinDistanceLimit(100);
		// layout.setInitialTemp(10);
		// layout.setForceConstant(10);
		// layout.setDisableEdgeStyle(true);
		// layout.execute(mGraph.getDefaultParent());
	}

	public MainWindow() {
		super("Tropical PM");
		try {
			// Set the required look and feel
			UIManager
					.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
			// Update the component tree - associate the look and feel with the
			// given frame.
			SwingUtilities.updateComponentTreeUI(this);
		}// end try
		catch (Exception ex) {
			ex.printStackTrace();
		}// end catch
		mw = this;
		Container pan = getContentPane();
		jmb = new JMenuBar();
		jmb.add(createFileMenu());
		jmb.add(createEditMenu());
		jmb.add(createViewMenu());
		jmb.add(createHelpMenu());
		setJMenuBar(jmb);
		// ///////////////////////////////
		// tabulates
		GridLayout gl = new GridLayout(1, 4, 10, 12);
		JTabbedPane jtb = new JTabbedPane(JTabbedPane.TOP,
				JTabbedPane.SCROLL_TAB_LAYOUT);
		JPanel tab1 = new JPanel();
		projecttree = new JTree(dtm);
		projecttree.addMouseListener(new TreeMouseListener());
		projecttree.setCellRenderer(new MyRenderer());
		ToolTipManager.sharedInstance().registerComponent(projecttree);
		if (thisproj.getAllJobs().isEmpty()) {
			projecttree.setVisible(false);
		}
		JScrollPane workDirectoryPanel = new JScrollPane(projecttree);
		workDirectoryPanel.setSize(200, 300);
		workDirectoryPanel.setBorder(BorderFactory
				.createTitledBorder("Work Directory"));
		workDirectoryPanel
				.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

		// workDirectoryPanel.add(projecttree);
		JPanel projectPanel = new JPanel();
		// projectPanel.setBorder(BorderFactory.createEtchedBorder());
		// projectPanel
		// .setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		// mGraph.set
		mGraph.setAllowDanglingEdges(false);
		mGraph.setCellsDeletable(false);
		mGraph.setCellsResizable(false);
		mGraph.setCellsCloneable(false);
		mGraph.setCellsEditable(false);
		mxGpraphComp.setCenterPage(true);
		mxGpraphComp.setCenterZoom(true);
		mxGpraphComp.setToolTips(true);
		mxGpraphComp.getGraphControl().addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2) {
					Object cell = mxGpraphComp.getCellAt(e.getX(), e.getY());
					if (cell != null && cell instanceof mxCell) {
						mxCell ce = (mxCell) cell;
						Object o = ce.getValue();
						if (o != null && o instanceof Job) {
							new JobEditWindow(mw, (Job) o);
						}
					}
				}
			}
		});
		GridLayout glzero = new GridLayout(1, 1, 100, 12);
		projectPanel.setLayout(glzero);
		projectPanel.add(mxGpraphComp);
		JSplitPane js2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true);

		js2.setTopComponent(projectPanel); // projectPanel);

		JSplitPane jsp = new JSplitPane();
		jsp.setRightComponent(js2);
		jsp.setOneTouchExpandable(true);
		jsp.setDividerSize(10);
		jsp.setDividerLocation(190);
		jsp.setLeftComponent(workDirectoryPanel);

		tab1.add(jsp);
		tab1.setLayout(gl);
		// //////////////////////////////////
		// //////////////////////////////////
		JSplitPane splitMain = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true);
		splitMain.setOneTouchExpandable(true);
		splitMain.setDividerSize(10);
		splitMain.setDividerLocation(290);
		//    
		// JScrollPane timeViewPanel = new JScrollPane();
		timeViewPanel = new JPanel();
		timeViewPanel.add(new JLabel("fsdfsdfdsfsd"));
		timeViewPanel.setSize(200, 300);
		timeViewPanel.setBorder(BorderFactory.createTitledBorder("Time View"));
		timeViewPanel.setOpaque(true);
		timeViewPanel.setBackground(Color.WHITE);
		timeViewPanel.repaint();
		timeViewPanel.removeAll();
		scroll = new JScrollPane(timeViewPanel);
		GanttChart gan = new GanttChart();
		// project = createDataset(gan);
		// gan.setModel(project);
		scroll.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scroll.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		// timeViewPanel.add(chp);
		timeViewPanel.add(gan);
		String[] headers = { "ID", "Worker", "Work start time", "Work end time" };
		// Object[][] data = { { "ID" }, { "Worker", "Work Time" } };
		defTalbe.setColumnIdentifiers(headers);
		jtable = new JTable(defTalbe);
		jtable.setCellSelectionEnabled(false);
		jtable.setRowHeight(40);
		jtable.addMouseListener(new TableMouseListener());
		JScrollPane tableViewPanel = new JScrollPane(jtable);
		tableViewPanel.setSize(200, 300);
		tableViewPanel
				.setBorder(BorderFactory.createTitledBorder("Table View"));
		tableViewPanel
				.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		// scroll.add(timeViewPanel);
		splitMain.setTopComponent(scroll);
		splitMain.setBottomComponent(tableViewPanel);
		JPanel tab2 = new JPanel();
		gl = new GridLayout(1, 1, 10, 12);
		tab2.setLayout(gl);
		tab2.add(splitMain);
		jtb.addTab("Jobs", tab1);
		jtb.addTab("Resources", tab2);
		// ///////////////////////////////////////
		// toolbar
		JToolBar jtoolBar = new JToolBar();
		jtoolBar.add(new NewProject());
		jtoolBar.add(new OpenProject());
		jtoolBar.add(new SaveProject());
		jtoolBar.add(new SaveAsProject());
		Object[] arrTimeUnit = { "Hour", "Day", "Week", "Month", "Year" };
		DefaultComboBoxModel dcmbtimeUnit = new DefaultComboBoxModel(
				arrTimeUnit);
		JComboBox<Object> jcmTime = new JComboBox<Object>(dcmbtimeUnit);
		jcmTime.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent e) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					//   
					final Object item = e.getItem();
					switch ((String) item) {
					case "Week":
						PRECIZE = "Week";
						break;
					case "Day":
						PRECIZE = "Day";
						break;
					case "Month":
						PRECIZE = "Month";
						break;
					case "Year":
						PRECIZE = "Year";
						break;
					}
					updateGUI();
				}
			}
		});
		jtoolBar.add(Box.createGlue());
		jtoolBar.add(new JLabel("TimeUnit: "));
		jtoolBar.add(jcmTime);
		jtoolBar.add(Box.createGlue());
		jtoolBar.add(new AddJob());
		jtoolBar.add(new AddRes());
		jtoolBar.addSeparator();
		jtoolBar.add(new ViewStartStart());
		jtoolBar.add(Box.createGlue());
		JCheckBox jchbox = new JCheckBox("Instant solution");
		jtoolBar.add(jchbox);
		jtoolBar.addSeparator();
		jtoolBar.add(new JLabel("Optimization criteria: "));
		Object[] arrOpt = { "Just-in-time", "Makespan", "Full-time",
				"Fixed time", "Maximum deviation" };
		DefaultComboBoxModel dcmbprev = new DefaultComboBoxModel(arrOpt);
		JComboBox<Object> jcm = new JComboBox<Object>(dcmbprev);
		jcm.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					for (Job j : thisproj.getAllJobs()) {
						System.out.println(j.getName() + "Start "
								+ j.getStartTime() + " Stop " + j.getStopTime());
					}
					final Object item = e.getItem();
					List<Matrix> info = collectInformation();
					List<Matrix> result = new LinkedList<Matrix>();
					switch ((String) item) {
					case "Makespan":
						result = Scheduling.makeSpan(info.get(0), info.get(1),
								info.get(2), info.get(3));
						break;
					case "Fixed time":
						Object[] obj = { "", "", "" };
						int n = JOptionPane
								.showOptionDialog(
										getParent(),
										"       ?",
										" ",
										JOptionPane.YES_NO_CANCEL_OPTION,
										JOptionPane.QUESTION_MESSAGE, null,
										obj, obj[0]);
						switch (n) {
						case 0:
							result = Scheduling.plannedTerms(info.get(0),
									info.get(1), info.get(2), info.get(3));
							;
							break;
						case 1:
							cmm = new ConstraintsAddWindow(thisproj, mw, info);
							result = Scheduling.plannedTerms(info.get(0),
									info.get(1), info.get(2), bConst);
						case 2:
							return;
						}
						break;
					case "Full-time":
						result = Scheduling.fullTimeOptimization(info.get(0),
								info.get(1), info.get(2), info.get(3));
						break;
					case "Maximum deviation":
						result = Scheduling.maximumDeviation(info.get(0),
								info.get(1), info.get(2), info.get(3));
						break;
					case "Just-in-time":
						result = Scheduling.justInTime(info.get(0),
								info.get(1), info.get(2), info.get(3));
						break;
					}
					if (result == null) {
						JOptionPane.showMessageDialog(new JFrame(),
								"Constraint are not feasible!", "Dialog",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
					Matrix a = result.get(0);// x
					Matrix b = result.get(1);// y
					System.out.print(a);
					System.out.print(b);
					double lag = 0;
					if (a.getValueAt(0, 0) < 0) {
						lag = a.getValueAt(0, 0);
					}
					Date startfirst = null;
					for (int i = 0; i < a.getRowSize(); i++) {
						a.setValueAt(a.getValueAt(i, 0) - lag, i, 0);
						b.setValueAt(b.getValueAt(i, 0) - lag, i, 0);
						Job j = thisproj.getAllJobs().get(i);
						if (i == 0) {
							startfirst = new Date(j.getStartTime().getTime());
						}
						Date start = new Date(j.getStartTime().getTime());
						double length = b.getValueAt(i, 0) - a.getValueAt(i, 0);
						double startvalue = a.getValueAt(i, 0);
						switch (PRECIZE_OF_MATRIX) {
						case "sec":
							length = length * 1000;
							startvalue = startvalue * 1000;
							break;
						case "min":
							length = length * 1000;
							startvalue = startvalue * 1000;
							startvalue = startvalue * 60;
							length = length * 60;
							break;
						case "Hour":
							length = length * 1000;
							startvalue = startvalue * 1000;
							startvalue = startvalue * 60;
							startvalue = startvalue * 60;
							length = length * 60;
							length = length * 60;
							break;
						case "Day":
							length = length * 1000;
							startvalue = startvalue * 1000;
							startvalue = startvalue * 60;
							startvalue = startvalue * 60;
							startvalue = startvalue * 24;
							length = length * 60;
							length = length * 60;
							length = length * 24;
							break;
						}
						if (i == 0) {
							long l = (long) length;
							j.setStopTime(new Date(start.getTime() + l));
						} else {
							j.setStartTime(new Date(startfirst.getTime()
									+ (long) startvalue));
							j.setStopTime(new Date(j.getStartTime().getTime()
									+ (long) length));

						}
					}
					for (Job j : thisproj.getAllJobs()) {
						System.out.println(j.getName() + "Start "
								+ j.getStartTime() + " Stop " + j.getStopTime());
					}
					updateGUI();
				}
			}
		});
		jtoolBar.add(jcm);
		getContentPane().add(jtoolBar, "North");

		getContentPane().add(jtb);
		setSize(1000, 700);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				Object[] obj = { "", "", "" };
				int n = JOptionPane.showOptionDialog(getParent(),
						"C   ?",
						"  Tropical PM",
						JOptionPane.YES_NO_CANCEL_OPTION,
						JOptionPane.QUESTION_MESSAGE, null, obj, obj[0]);
				switch (n) {
				case 0:
					jmb.getMenu(0).getItem(1).doClick();
					;
					break;
				case 1:
					System.exit(0);
				case 2:
					return;
				}
			}
		});
		setVisible(true);
	}

	private GanttChart createDataset() {
		GanttChart gan = new GanttChart();
		switch (PRECIZE) {
		case "Week":
			gan.setTimeUnit(TimeUnit.Week);
			break;
		case "Day":
			gan.setTimeUnit(TimeUnit.Day);
			break;
		case "Month":
			gan.setTimeUnit(TimeUnit.Month);
			break;
		case "Year":
			gan.setTimeUnit(TimeUnit.Year);
			break;
		}
		GanttModel model = new GanttModel();
		model.setKickoffTime(new Time(thisproj.getStartTime()));
		model.setDeadline(new Time(new GregorianCalendar(2014, 0, 30)));
		Task s1 = new Task();
		s1.setUserObject(thisproj);
		s1.setName(thisproj.getName());
		s1.setStart(new Time(thisproj.getStartTime()));
		s1.setEnd(new Time(thisproj.getStopTime()));
		LinkedList<Task> llTask = new LinkedList<Task>();
		for (Job j : thisproj.getAllJobs()) {
			Task t = new Task(j.getName(), new Time(j.getStartTime()),
					new Time(j.getStopTime()));
			t.setUserObject(j);
			llTask.add(t);
		}
		for (Job j : thisproj.getAllJobs()) {
			for (Job prev : j.getPreviousJob()) {
				int k = thisproj.getAllJobs().indexOf(prev);
				int i = thisproj.getAllJobs().indexOf(j);
				llTask.get(i).addPredecessor(llTask.get(k));
			}
		}
		System.out.println(llTask.size());
		Task[] tarr = new Task[llTask.size()];
		int k = 0;
		for (Task t : llTask) {
			tarr[k++] = t;
		}
		s1.removeAllChildren();
		s1.add(tarr);
		// System.out.println(model.getTasksByBFS().size());
		model.addTask(s1);
		gan.setModel(model);
		return gan;
	}

	private static Date date(final int day, final int month, final int year) {

		final Calendar calendar = Calendar.getInstance();
		calendar.set(year, month, day);
		final Date result = calendar.getTime();
		return result;

	}

	/*
	 * private JFreeChart createChart(IntervalCategoryDataset dataset) { final
	 * JFreeChart chart = ChartFactory.createGanttChart( thisproj.getName(), //
	 * chart title "Jobs", // domain axis label "Date", // range axis label
	 * dataset, // data true, // include legend true, // tooltips false // urls
	 * ); //
	 * chart.getCategoryPlot().getDomainAxis().setMaxCategoryLabelWidthRatio
	 * (10.0f); return chart; }
	 */
	private JMenu createHelpMenu() {
		JMenu jm1 = new JMenu("Help");
		JMenuItem jmi1 = new JMenuItem("About");
		jm1.add(jmi1);
		jmi1.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				new HelpWindow();
			}
		});
		return jm1;
	}

	private JMenu createViewMenu() {
		JMenu jm1 = new JMenu("View");
		JMenuItem jmi1 = new JMenuItem("Project");
		JMenuItem jmi2 = new JMenuItem("Job");
		JMenuItem jmi3 = new JMenuItem("Time Chart");
		JMenuItem jmi4 = new JMenuItem("Resource Table");
		jm1.add(jmi1);
		jm1.add(jmi2);
		jm1.addSeparator();
		jm1.add(jmi3);
		jm1.add(jmi4);
		return jm1;
	}

	private JMenu createEditMenu() {
		JMenu jm1 = new JMenu("Edit");
		JMenuItem jmi1 = new JMenuItem("New Job", new ImageIcon(
				"src/IMG/job.jpg"));
		jmi1.setMnemonic(KeyEvent.VK_J);
		jmi1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_J,
				ActionEvent.CTRL_MASK));
		jmi1.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				new JobAddWindow(mw);
			}
		});
		JMenuItem jmi2 = new JMenuItem("New Resource", new ImageIcon(
				"src/IMG/res.jpg"));
		jmi2.setMnemonic(KeyEvent.VK_R);
		jmi2.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,
				ActionEvent.CTRL_MASK));
		jmi2.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent arg0) {
				new ResourceAddWindow();
			}
		});
		JMenu jmi3 = new JMenu("hoose Language");
		jmi3.add(new JMenuItem("English"));
		jmi3.add(new JMenuItem("Russian"));
		// JMenuItem jmi4 = new JMenuItem("Redo");
		jm1.add(jmi1);
		jm1.add(jmi2);
		jm1.addSeparator();
		jm1.add(jmi3);
		// jm1.add(jmi4);
		return jm1;
	}

	private JMenu createFileMenu() {
		JMenu jm1 = new JMenu("File");
		JMenuItem jmi1 = new JMenuItem("Open Project", new ImageIcon(
				"src/IMG/open.jpg"));
		jmi1.setMnemonic(KeyEvent.VK_O);
		jmi1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
				ActionEvent.CTRL_MASK));
		jmi1.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser jfch = new JFileChooser();
				FileNameExtensionFilter filter = new FileNameExtensionFilter(
						"Tropical Project Files", "tproj");
				jfch.setFileFilter(filter);
				int returnvalue = jfch.showOpenDialog(getParent());
				if (returnvalue == JFileChooser.APPROVE_OPTION) {
					File f = jfch.getSelectedFile();
					System.out.println(f.getAbsolutePath());
					try {
						ObjectInputStream oos = new ObjectInputStream(
								new FileInputStream(f));
						MainClass.setProject((Project) oos.readObject());
						thisproj = MainClass.getInstance();
						thisproj.setMainWindow(mw);
						String ob = f.getCanonicalPath();
						// reDrawGraph(mGraph, thisproj);
						updateGUI();
						oos.close();
					} catch (IOException e) {
						e.printStackTrace();
					} catch (ClassCastException e) {

						e.printStackTrace();
					} catch (ClassNotFoundException e) {
						e.printStackTrace();
					}

				}

			}
		});

		JMenuItem jmi2 = new JMenuItem("Save Project", new ImageIcon(
				"src/IMG/save.jpg"));
		jmi2.setMnemonic(KeyEvent.VK_S);
		jmi2.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,
				ActionEvent.CTRL_MASK));
		jmi2.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser jfch = new JFileChooser(".tproj");

				FileNameExtensionFilter filter = new FileNameExtensionFilter(
						"Tropical Project Files", "tproj");
				jfch.setFileFilter(filter);
				// jfch.set;
				int returnvalue = jfch.showSaveDialog(getParent());
				if (returnvalue == JFileChooser.APPROVE_OPTION) {
					File f = jfch.getSelectedFile();
					String name = f.getName();

					f.renameTo(new File(name + ".tproj"));
					System.out.println(f.getAbsolutePath());
					try {
						ObjectOutputStream oos = new ObjectOutputStream(
								new FileOutputStream(f));
						oos.writeObject(thisproj);
						oos.writeInt(thisproj.getAllJobs().size());
						for (Job j : thisproj.getAllJobs()) {
							oos.writeObject(j);
						}
						oos.writeInt(thisproj.getAllResources().size());
						for (Resource j : thisproj.getAllResources()) {
							oos.writeObject(j);
						}
						oos.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

				}

			}
		});
		JMenuItem jmi25 = new JMenuItem("Save Project As...", new ImageIcon(
				"src/IMG/saveas.jpg"));
		JMenuItem jmi3 = new JMenuItem("Exit",
				new ImageIcon("src/IMG/exit.jpg"));

		jmi3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		jm1.add(jmi1);
		jm1.add(jmi2);
		jm1.add(jmi25);
		jm1.addSeparator();
		jm1.add(jmi3);
		return jm1;
	}

	Map<Job, DefaultMutableTreeNode> guires = new HashMap<Job, DefaultMutableTreeNode>();
	Map<DefaultMutableTreeNode, DefaultMutableTreeNode> nn = new HashMap<DefaultMutableTreeNode, DefaultMutableTreeNode>();

	public void updateGUI() {
		System.out.println(thisproj);
		System.out.println(thisproj.getAllJobs());
		for (Job j : thisproj.getAllJobs()) {
			System.out.println(j + "Prev " + j.getPreviousJob() + "\r\nNext "
					+ j.getNextJob());
			guijob.put(j, j.getResource());
		}
		System.out.println(thisproj.getAllResources());
		for (Resource j : thisproj.getAllResources())
			System.out.println(j);

		GanttChart gan = createDataset();
		final Integer clickcount = 0;
		gan.addSelectionChangeListener(new SelectionChangeListener() {
			@Override
			public void selectionChanged(SelectionChangeEvent e) {
				if (e.getSelection() != null) {
					Task t = e.getSelection();
					Object i = t.getUserObject();
					Integer.sum(clickcount, 1);
					if (i instanceof Job && clickcount % 2 == 0) {
						new JobEditWindow(mw, (Job) i);
					}
				}
			}
		});
		// System.out.println(project.getTasksByBFS().size());
		timeViewPanel.setOpaque(true);

		timeViewPanel.setBackground(Color.WHITE);
		timeViewPanel.removeAll();
		// timeViewPanel.add(chp);
		timeViewPanel.add(gan);
		timeViewPanel.repaint();
		scroll.repaint();
		((DefaultMutableTreeNode) dtm.getRoot()).removeAllChildren();
		dtm.reload();
		if (!thisproj.getAllJobs().isEmpty()) {
			projecttree.setVisible(true);
		}
		//           
		for (Job j : thisproj.getAllJobs()) {
			// dtm.removeNodeFromParent(root);
			DefaultMutableTreeNode dmtn;
			// if (!guires.containsKey(j)) {
			dmtn = new DefaultMutableTreeNode(j);
			//
			// guires.put(j, dmtn);
			// nn.put(dmtn, null);
			// } else {
			// dmtn = guires.get(j);
			// }
			// if (!guijob.containsKey(j)) {

			dtm.insertNodeInto(dmtn, root, root.getChildCount());
			// guijob.put(j, null);
			// }
			// if (j.hasWorker()) {
			boolean foundres = false;
			for (Map.Entry<Job, Resource> en : guijob.entrySet()) {
				if (en.getKey() == j && en.getValue() == j.getResource()) {
					foundres = true;
					break;
				}
				// }
				if (!foundres) {
					DefaultMutableTreeNode dftn = new DefaultMutableTreeNode(
							j.getResource());
					dtm.insertNodeInto(dftn, dmtn, dmtn.getChildCount());
					// nn.put(dmtn, dftn);
					// guijob.put(j, j.getResource());
				}
			}

		}
		//           
		// 
		// for (Job j : guijob.keySet()) {
		// Resource r = guijob.get(j);
		// boolean hassisjob = false;
		// for (Map.Entry<Job, Resource> en : guijob.entrySet()) {
		// if (en.getKey() == j && en.getValue() == j.getResource()) {
		// hassisjob = true;
		// break;
		// }
		// }
		// if (hassisjob) {
		// continue;
		// } else {
		// int chco = guires.get(j).getChildCount();
		// if (j.getResource() != null) {
		// guires.get(j).remove(0);// only one index
		// dtm.reload();
		// nn.remove(j);
		// guijob.remove(j);
		// guijob.put(j, null);
		// DefaultMutableTreeNode dftn = new DefaultMutableTreeNode(
		// j.getResource());
		// dtm.insertNodeInto(dftn, guires.get(j), guires.get(j)
		// .getChildCount());
		//
		// }
		// }

		// }
		reDrawGraph(mGraph, thisproj);
		reDrawTable(jtable, defTalbe, thisproj);
		this.repaint();
		collectInformation();

	}

	public void compareMatrix() {

	}

	public List<Matrix> collectInformation() {
		LinkedList<Matrix> ll = new LinkedList<Matrix>();
		int n = thisproj.getAllJobs().size();
		if (C == null) {
			C = new Matrix(n, n);
		} else {
			if (C.getRowSize() != n) {
				C.setRowSize(n, Double.NEGATIVE_INFINITY);
			}
			if (C.getColumnSize() != n) {
				C.setColumnSize(n, Double.NEGATIVE_INFINITY);
			}
		}
		// start finish matrix
		if (A == null) {
			A = new Matrix(n, n);
		} else {
			if (A.getRowSize() != n) {
				A.setRowSize(n, Double.NEGATIVE_INFINITY);
			}
			if (A.getColumnSize() != n) {
				A.setColumnSize(n, Double.NEGATIVE_INFINITY);
			}
		}
		for (int i = 0; i < n; i++) {
			Job job = thisproj.getAllJobs().get(i);
			LinkedList<Job> prevj = new LinkedList<Job>(job.getPreviousJob());
			prevj.add(job);
			if (prevj.isEmpty()) {
				continue;
			}
			for (Job jes : prevj) {
				int j = thisproj.getAllJobs().indexOf(jes);
				if (jes == job) {
					A.setValueAt(jes.getLength(), i, i);
					continue;

				}
				/*
				 * double timelag; if (jes == job) { timelag =
				 * job.getStopTime().getTime() - jes.getStartTime().getTime(); }
				 * else { timelag = job.getStartTime().getTime() -
				 * jes.getStopTime().getTime(); } switch (PRECIZE_OF_MATRIX) {
				 * case "sec": timelag = timelag / 1000.0; break; case "min":
				 * timelag = timelag / 1000.0; timelag = timelag / 60.0; break;
				 * case "Hour": timelag = timelag / 1000.0; timelag = timelag /
				 * 60.0; timelag = timelag / 60.0; break; case "day": timelag =
				 * timelag / 1000.0; timelag = timelag / 60.0; timelag = timelag
				 * / 60.0; timelag = timelag / 24.0; break; }
				 */
				if (C.getValueAt(i, j) == Double.NEGATIVE_INFINITY)
					C.setValueAt(0, i, j);
			}
		}
		// start start matrix!!&!&!&
		Matrix b = Evaluations.matrixMultip(C, A);
		// for (int i = 0; i < b.getColumnSize(); i++)
		// b.setValueAt(Double.NEGATIVE_INFINITY, i, i);
		ll.add(A);
		ll.add(b);
		Matrix g = new Matrix(A.getColumnSize(), 1);
		Matrix h = new Matrix(A.getColumnSize(), 1);
		if (thisproj.getAllJobs().isEmpty())
			return null;
		Date st = thisproj.getAllJobs().get(0).getStartTime();

		for (int i = 0; i < thisproj.getAllJobs().size(); i++) {
			double razn1 = thisproj.getAllJobs().get(i).getStartTime()
					.getTime()
					- st.getTime();
			double razn2 = thisproj.getAllJobs().get(i).getStopTime().getTime()
					- st.getTime();
			switch (PRECIZE_OF_MATRIX) {
			case "sec":
				razn1 = razn1 / 1000.0;
				razn2 = razn2 / 1000.0;
				break;
			case "min":
				razn1 = razn1 / 1000.0;
				razn2 = razn2 / 1000.0;
				razn1 = razn1 / 60.0;
				razn2 = razn2 / 60.0;
				break;
			case "Hour":
				razn1 = razn1 / 1000.0;
				razn2 = razn2 / 1000.0;
				razn1 = razn1 / 60.0;
				razn2 = razn2 / 60.0;
				razn1 = razn1 / 60.0;
				razn2 = razn2 / 60.0;
				break;
			case "Day":
				razn1 = razn1 / 1000.0;
				razn2 = razn2 / 1000.0;
				razn1 = razn1 / 60.0;
				razn2 = razn2 / 60.0;
				razn1 = razn1 / 60.0;
				razn2 = razn2 / 60.0;
				razn1 = razn1 / 24.0;
				razn2 = razn2 / 24.0;
				break;
			}
			g.setValueAt(razn1, i, 0);
			h.setValueAt(razn2, i, 0);

		}
		ll.add(g);
		ll.add(h);
		ll.add(C);
		return ll;
	}

	private class TreeMouseListener extends MouseAdapter {
		@Override
		public void mouseClicked(MouseEvent e) {
			int selRow = projecttree.getRowForLocation(e.getX(), e.getY());
			TreePath selPath = projecttree.getPathForLocation(e.getX(),
					e.getY());
			if (selRow != -1) {
				if (e.getClickCount() == 1) {
				} else if (e.getClickCount() == 2) {
					DefaultMutableTreeNode selectedNode = ((DefaultMutableTreeNode) selPath
							.getLastPathComponent());
					Object o = selectedNode.getUserObject();
					if (o != null) {
						if (o instanceof Job) {
							new JobEditWindow(mw, (Job) o);
						}
						if (o instanceof Resource) {
							new ResourceEditWindow((Resource) o);
						}
					}
				}

			}
		}
	}

	private class TableMouseListener extends MouseAdapter {
		@Override
		public void mouseClicked(MouseEvent e) {
			if (e.getClickCount() == 2) {
				JTable target = (JTable) e.getSource();
				int row = target.getSelectedRow();
				int column = target.getSelectedColumn();
				Object o = target.getModel().getValueAt(row, 1);
				if (o instanceof Job) {
					new JobEditWindow(mw, (Job) o);
				}
				if (o instanceof Resource) {
					new ResourceEditWindow((Resource) o);
				}

				// do some action
			}
		}
	}

	private class MyRenderer extends DefaultTreeCellRenderer {
		public Component getTreeCellRendererComponent(JTree tree, Object value,
				boolean sel, boolean expanded, boolean leaf, int row,
				boolean hasFocus) {
			JLabel component = (JLabel) super.getTreeCellRendererComponent(
					tree, value, sel, expanded, leaf, row, hasFocus);
			DefaultMutableTreeNode dtn = (DefaultMutableTreeNode) value;

			if (dtn.getUserObject() instanceof Job) {
				Job j = (Job) dtn.getUserObject();
				component.setToolTipText(j.getFullInfo());
			}
			if (dtn.getUserObject() instanceof Project) {
				Project j = (Project) dtn.getUserObject();
				component.setToolTipText(j.getFullInfo());
			}
			if (dtn.getUserObject() instanceof Resource) {
				Resource j = (Resource) dtn.getUserObject();
				component.setToolTipText(j.getFullInfo());
			}

			return component;
		}
	}

	private class NewProject extends AbstractAction {
		public NewProject() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/newproject.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION, "Create new Project");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			thisproj = new Project("", mw);
			MainClass.setProject(thisproj);
			updateGUI();
			clearAll();
		}

	}

	private class OpenProject extends AbstractAction {
		public OpenProject() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/open.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION, "Open Project");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			jmb.getMenu(0).getItem(0).doClick();
		}

	}

	private class SaveProject extends AbstractAction {
		public SaveProject() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/saveproject.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION, "Save Project");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			jmb.getMenu(0).getItem(1).doClick();
		}

	}

	private class SaveAsProject extends AbstractAction {
		public SaveAsProject() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/saveasproject.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION, "Save Project As....");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			jmb.getMenu(0).getItem(1).doClick();
		}

	}

	private class AddJob extends AbstractAction {
		public AddJob() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/restoolbar.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION, "Add Resource");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			jmb.getMenu(1).getItem(1).doClick();
		}
	}

	private class AddRes extends AbstractAction {
		public AddRes() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/task.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION, "Add Job");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			jmb.getMenu(1).getItem(0).doClick();
		}
	}

	public void collectInfoMatrix() {
		List<Matrix> ll = mm.collectInfo();
		A = ll.get(0);
		C = ll.get(1);
		B = ll.get(2);
	}

	private class ViewStartStart extends AbstractAction {
		public ViewStartStart() {
			putValue(AbstractAction.SMALL_ICON, new ImageIcon(
					"src/IMG/startstart.jpg"));
			putValue(AbstractAction.SHORT_DESCRIPTION,
					"View matrices of constraints");
		}

		@Override
		public void actionPerformed(ActionEvent e) {
			mm = new MatrixWindow(thisproj, mw, collectInformation());
		}
	}

	public void collectInfoMatrixCosntraints() {
		bConst = cmm.collectInfo();

	}

}
