package GUI;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.LinkedList;
import java.util.List;
import java.util.Observer;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;

import MainPackage.Job;
import MainPackage.Project;
import Tropical.Mathematics.Matrix;

public class MatrixWindow extends JFrame {
	final Matrix a, c, b;
	final JTable tab;
	int count = 0;
	Object[] arr = { "Start - finish", "Start - start", "Incidence" };
	DefaultComboBoxModel<Object> def = new DefaultComboBoxModel<>(arr);
	JComboBox<Object> jcmb = new JComboBox<Object>(def);;
	List<Matrix> thislist;

	public MatrixWindow(final Project p, final MainWindow mw, List<Matrix> list) {

		super("Matrices of constraints.");
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		a = list.get(0);
		c = list.get(1);
		b = list.get(list.size() - 1);
		int n = a.getColumnSize();
		tab = new JTable(n + 1, n + 1);
		DefaultTableModel dtm = new DefaultTableModel() {
			public boolean isCellEditable(int row, int column) {
				if (row == 0 || column == 0) {
					return false;
				} else {
					return true;
				}
			}
		};
		dtm.setRowCount(n + 1);
		dtm.setColumnCount(n + 1);
		dtm.addTableModelListener(new TableListener());
		tab.setModel(dtm);

		// DefaultTableModel dtm = new DefaultTableModel();
		// tab.setModel(dtm);
		fillTable(a, p);
		jcmb.addItemListener(new ItemListener() {

			@Override
			public void itemStateChanged(ItemEvent e) {
				if (e.getStateChange() == ItemEvent.SELECTED) {
					//   
					final Object item = e.getItem();
					if ((String) item == "Start - finish") {
						fillTable(a, p);
					} else {
						if ((String) item == "Start - start") {
							fillTable(c, p);
						} else {
							fillTable(b, p);
						}
					}
				}
			}
		});
		JPanel jp = new JPanel();
		BoxLayout bl = new BoxLayout(jp, BoxLayout.Y_AXIS);
		jp.setLayout(bl);
		jp.add(Box.createVerticalGlue());
		JLabel lab = new JLabel("  : ");
		lab.setAlignmentX(lab.CENTER_ALIGNMENT);
		lab.setAlignmentY(lab.TOP_ALIGNMENT);
		jp.add(lab);
		jp.add(jcmb);
		jp.add(tab);
		// getContentPane().add(jcmb, "North");
		getContentPane().add(jp);
		setSize(300, 200);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {
				mw.collectInfoMatrix();
			}
		});
		pack();
		setVisible(true);
		// TODO Auto-generated constructor stub
	}

	public List<Matrix> collectInfo() {
		LinkedList<Matrix> ll = new LinkedList<Matrix>();
		ll.add(a);
		ll.add(c);
		ll.add(b);
		return ll;
	}

	public void fillTable(Matrix m, Project p) {
		int n = m.getColumnSize();

		Object[] jobsname = new Object[n];
		int k = 0;
		for (Job j : p.getAllJobs())
			jobsname[k++] = j.getName();
		for (int i = 0; i < n + 1; i++) {
			for (int j = 0; j < n + 1; j++) {
				if ((i == 0 && j == 0))
					continue;
				if ((i == 0 || j == 0)) {
					tab.getModel().setValueAt(jobsname[i + j - 1], i, j);
				} else {
					tab.getModel().setValueAt(m.getValueAt(i - 1, j - 1), i, j);
				}
			}
		}

	}

	class TableListener implements TableModelListener {

		@Override
		public void tableChanged(TableModelEvent e) {

			// System.out.println(e.getSource());
			int y = e.getLastRow();
			int x = e.getColumn();

			System.out.print(e.getColumn() + " ");
			System.out.println(e.getLastRow());
			if (x == 0 || y == 0) {
				return;
			}
			double value = 0;
			int rowcount = tab.getRowCount() - 1;
			if (!(tab.getModel().getValueAt(y, x) instanceof Double)) {

				String s = (String) tab.getModel().getValueAt(y, x);
				if (s == "-Infinity") {
					value = Double.NEGATIVE_INFINITY;
				} else {
					try {
						value = Double.valueOf(s);
					} catch (NumberFormatException ex) {
						JOptionPane.showMessageDialog(new JFrame(),
								"Incorrect input!!", "Dialog",
								JOptionPane.ERROR_MESSAGE);
						return;
					}
				}
				if ((String) jcmb.getSelectedItem() == "Start - start") {
					if (!((y - 1) == (x - 1))) {
						MatrixWindow.this.c.setValueAt(value, y - 1, x - 1);
					}
				} else {
					if ((String) jcmb.getSelectedItem() == "Start - finish") {
						if (!((y - 1) == (x - 1))) {
							MatrixWindow.this.a.setValueAt(value, y - 1, x - 1);
						}
					} else {
						MatrixWindow.this.b.setValueAt(value, y - 1, x - 1);
					}
				}
			}
		}
	}

}
