package GUI;

import java.awt.*;
import java.awt.color.CMMException;
import java.awt.event.*;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.swing.*;

import MainPackage.*;

public class ResourceAddWindow extends JFrame {
	Project thisproj = MainClass.getInstance();
	LinkedList<Resource> resourcelist;
	LinkedList<Job> jobslist;

	public ResourceAddWindow() {
		super("Add new Resource");
		final JFrame jf = this;
		setSize(400, 200);
		setResizable(false);
		setMaximumSize(new Dimension(500, 400));
		setMinimumSize(new Dimension(400, 200));
		setDefaultCloseOperation(HIDE_ON_CLOSE);
		final JLabel jobname = new JLabel("Enter the resource's title:");
		JLabel selectprev = new JLabel("Select job:");
		final JComboBox jcbprevjob; // soon i'll insert here jobs
		jobslist = thisproj.getAllUnusedJobs();
		resourcelist = thisproj.getAllResources();
		if (!thisproj.getAllJobs().isEmpty()) {
			Object[] jobsarray = thisproj.getAllUnusedJobs().toArray();
			DefaultComboBoxModel dcmbprev = new DefaultComboBoxModel(jobsarray);
			dcmbprev.addElement(null);
			jcbprevjob = new JComboBox(dcmbprev);
		} else {
			jcbprevjob = new JComboBox();
		}
		final JTextField jtf = new JTextField("Resource#" + resourcelist.size());
		JPanel choisepan = new JPanel();
		BoxLayout bl = new BoxLayout(choisepan, BoxLayout.Y_AXIS);
		choisepan.setLayout(bl);
		choisepan.add(jobname);
		choisepan.add(jtf);
		choisepan.add(selectprev);
		choisepan.add(jcbprevjob);

		JButton butOk = new JButton("Add");
		butOk.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (jobslist.isEmpty()) {
					thisproj.addResource(new Resource(jtf.getText()));
				} else {
					Job prevjob = (Job) jcbprevjob.getSelectedItem();
					thisproj.addResource(new Resource(jtf.getText(), prevjob));

				}
				jf.dispose();
			}
		});
		JButton butCan = new JButton("Cancel");
		butCan.addActionListener(new ActionListener() {

			public void actionPerformed(ActionEvent arg0) {
				jf.dispose();

			}
		});
		getContentPane().add(choisepan, "North");
		JPanel butpan = new JPanel();
		bl = new BoxLayout(butpan, BoxLayout.X_AXIS);
		butpan.setLayout(bl);
		butpan.add(butOk, "South");
		butpan.add(Box.createHorizontalStrut(10));
		butpan.add(butCan, "South");
		butpan.add(Box.createHorizontalStrut(10));
		getContentPane().add(butpan, "East");
		setVisible(true);
	}
}
