package MainPackage;

import java.io.Serializable;
import java.util.Calendar;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import GUI.MainWindow;

public class Project implements Serializable {
	private static long allprojectid = 0;
	public final long thisprojectid = allprojectid++;

	private String nameproj;
	private LinkedList<Job> jobs = new LinkedList<>();
	private LinkedList<Resource> res = new LinkedList<Resource>();
	transient private MainWindow mw;
	private Date starttime = new Date(), endtime = new Date();
	Job startJob, endJob;

	public Project(String name, MainWindow mw) {
		this.nameproj = name;
		this.mw = mw;
	}

	public Date getStopTime() {
		return endtime;
	}

	public Date getStartTime() {
		return starttime;
	}

	private void setStopTime() {
		if (jobs.isEmpty())
			return;
		Date st = getAllJobs().get(0).getStopTime();
		for (Job j : getAllJobs()) {
			if (st.after(j.getStopTime())) {
				st = j.getStartTime();
			}
		}
		endtime = st;
		/*
		 * boolean isstoptime = false; for (Job j : jobs) { if
		 * (!j.getNextJob().isEmpty()) { endtime =
		 * j.getNextJob().get(0).getStopTime(); endJob = j.getNextJob().get(0);
		 * isstoptime = true; } } if (isstoptime) this.endtime = mindate;
		 */
	}

	private void setStartTime() {
		if (jobs.isEmpty())
			return;
		Date st = getAllJobs().get(0).getStartTime();
		for (Job j : getAllJobs()) {
			if (st.after(j.getStartTime())) {
				st = j.getStartTime();
			}
		}
		starttime = st;
		/*
		 * @SuppressWarnings("deprecation") Date mindate = null; // startJob =
		 * jobs.get(0); boolean isstartime = false; for (Job j : jobs) { if
		 * (!j.getPreviousJob().isEmpty()) { mindate =
		 * j.getPreviousJob().get(0).getStartTime(); startJob =
		 * j.getPreviousJob().get(0); isstartime = true; } } if (isstartime)
		 * this.starttime = mindate;
		 */}

	public Project() {
		this.nameproj = "";
	}

	public void addGUI(MainWindow mw) {
		this.mw = mw;
	}

	public Project(String name) {
		this.nameproj = name;
	}

	public void valueChanged() {
		setStartTime();
		setStopTime();
		mw.updateGUI();
	}

	public void addResource(Resource name) {
		res.add(name);
		valueChanged();
	}

	public void addJob(Job name) {
		jobs.add(name);
		valueChanged();
	}

	public void removeJobFromResource(Resource r, Job name) {
		r.removeJob(name);
		valueChanged();
	}

	public void removeAllJobFromResource(Resource r) {
		r.removeAllJobs();
		valueChanged();

	}

	public void removeResourceFromJob(Job name) {
		name.removeResource();
		valueChanged();
	}

	// //////////////////////////////////
	// testing valideness of time bounds
	public void validateProject() {
		checkAllJobsHasWorkers();
	}

	public boolean isValidate() {
		return false;
	}

	public LinkedList<Job> getAllJobs() {
		return this.jobs;
	}

	public LinkedList<Resource> getAllResources() {
		return this.res;
	}

	// what jobs don't have resources
	public LinkedList<Job> getAllUnusedJobs() {
		LinkedList<Job> unused = new LinkedList<Job>();
		for (Job j : jobs) {
			if (!j.hasWorker())
				unused.add(j);
		}
		return unused;
	}

	@Override
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append("Project name: ");
		sb.append(nameproj);
		sb.append("\r\n id: ");
		sb.append(thisprojectid);
		sb.append("\r\n Total count of jobs: ");
		sb.append(jobs.size());
		sb.append("\r\n Total count of resources: ");
		sb.append(res.size());
		sb.append("\r\n Is validate: ");
		sb.append(isValidate());
		return sb.toString();
	}

	// does all jobs has it's resources
	private boolean checkAllJobsHasWorkers() {
		for (Job j : jobs) {
			if (!j.hasWorker())
				return false;
		}
		return true;
	}

	public String getName() {
		return this.nameproj + ": " + thisprojectid;
	}

	public void setMainWindow(MainWindow mw2) {
		this.mw = mw2;

	}

	public String getFullInfo() {
		return this.nameproj + ": " + thisprojectid + " Jobs: " + jobs.size()
				+ " Resources: " + res.size();
	}

}
