package MainPackage;

import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;

public class Resource implements Serializable {
	private static long allresourcesid = 0;
	public final long thisresourceid = allresourcesid++;
	// his own list, not affiliated
	// with total jobs list
	List<Job> myjobs = new LinkedList<Job>();
	private String name; // addname;
	Job curjob, nextjob;

	public Resource(String name2) {
		name = name2;
	}

	@Override
	public String toString() {
		return this.name;
	}

	public Resource(String name2, Job curjob) {
		this(name2);
		this.curjob = curjob;
		this.addJob(curjob);
	}

	public boolean removeJob(Job id) {
		if (this.myjobs.contains(id)) {
			this.myjobs.remove(id);
			id.removeResource();
			return true;
		}
		return false;
	}

	// adding job if it doesn't exist
	public boolean addJob(Job cjob) {
		if (myjobs.contains(cjob)) {
			return false;
		} else {
			myjobs.add(cjob);
			cjob.setResource(this);
		}
		return true;
	}

	public String getFullInfo() {
		// TODO Auto-generated method stub
		return this.name + " Jobs: " + myjobs.size();
	}

	public LinkedList<Job> getJobs() {
		// TODO Auto-generated method stub
		return (LinkedList<Job>) myjobs;
	}

	public void setName(String text) {
		this.name = text;
	}

	public void removeAllJobs() {
		
		for(Job j: myjobs){
			this.removeJob(j);
		}
		myjobs.clear();
	}

}
